/*
 * Copyright 2016 Arnaud Fonce <arnaud.fonce@r-w-x.net>.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package net.rwx.netbeans.netkafa.wizard;

import javax.swing.JFileChooser;
import javax.swing.JPanel;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import net.rwx.netbeans.netkafa.karaf.KarafServerInfoHelper;
import org.openide.util.Utilities;

/**
 *
 * @author Arnaud Fonce <arnaud.fonce@r-w-x.net>
 */
public class KarafWizardComponent extends JPanel implements DocumentListener {

    /**
     * Creates new form NewJPanel
     */
    public KarafWizardComponent() {
        initComponents();
        updateInfoAndValidate();
        karafNameTextField.getDocument().addDocumentListener(this);
        karafPathTextField.getDocument().addDocumentListener(this);
    }

    /**
     * This method is called from within the constructor to initialize the form. WARNING: Do NOT modify this code. The
     * content of this method is always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        karafNameLabel = new javax.swing.JLabel();
        karafNameTextField = new javax.swing.JTextField();
        karafPathLabel = new javax.swing.JLabel();
        karafPathTextField = new javax.swing.JTextField();
        karafServerInfoLabel = new javax.swing.JLabel();
        jLabel1 = new javax.swing.JLabel();
        cleanLabel = new javax.swing.JLabel();
        cleanCheckbox = new javax.swing.JCheckBox();
        debugPortLabel = new javax.swing.JLabel();
        debugPortTextField = new javax.swing.JTextField();
        fileChooserButton = new javax.swing.JButton();

        karafNameLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        org.openide.awt.Mnemonics.setLocalizedText(karafNameLabel, org.openide.util.NbBundle.getMessage(KarafWizardComponent.class, "KarafWizardComponent.karafNameLabel.text")); // NOI18N

        karafNameTextField.setText(org.openide.util.NbBundle.getMessage(KarafWizardComponent.class, "KarafWizardComponent.karafNameTextField.text")); // NOI18N

        karafPathLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        org.openide.awt.Mnemonics.setLocalizedText(karafPathLabel, org.openide.util.NbBundle.getMessage(KarafWizardComponent.class, "KarafWizardComponent.karafPathLabel.text")); // NOI18N

        karafPathTextField.setText(org.openide.util.NbBundle.getMessage(KarafWizardComponent.class, "KarafWizardComponent.karafPathTextField.text")); // NOI18N

        org.openide.awt.Mnemonics.setLocalizedText(karafServerInfoLabel, org.openide.util.NbBundle.getMessage(KarafWizardComponent.class, "KarafWizardComponent.karafServerInfoLabel.text")); // NOI18N

        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        org.openide.awt.Mnemonics.setLocalizedText(jLabel1, org.openide.util.NbBundle.getMessage(KarafWizardComponent.class, "KarafWizardComponent.jLabel1.text")); // NOI18N

        cleanLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        org.openide.awt.Mnemonics.setLocalizedText(cleanLabel, org.openide.util.NbBundle.getMessage(KarafWizardComponent.class, "KarafWizardComponent.cleanLabel.text")); // NOI18N

        org.openide.awt.Mnemonics.setLocalizedText(cleanCheckbox, org.openide.util.NbBundle.getMessage(KarafWizardComponent.class, "KarafWizardComponent.cleanCheckbox.text")); // NOI18N
        cleanCheckbox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cleanCheckboxActionPerformed(evt);
            }
        });

        debugPortLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        org.openide.awt.Mnemonics.setLocalizedText(debugPortLabel, org.openide.util.NbBundle.getMessage(KarafWizardComponent.class, "KarafWizardComponent.debugPortLabel.text")); // NOI18N

        debugPortTextField.setText(org.openide.util.NbBundle.getMessage(KarafWizardComponent.class, "KarafWizardComponent.debugPortTextField.text")); // NOI18N
        debugPortTextField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                debugPortTextFieldActionPerformed(evt);
            }
        });

        org.openide.awt.Mnemonics.setLocalizedText(fileChooserButton, org.openide.util.NbBundle.getMessage(KarafWizardComponent.class, "KarafWizardComponent.fileChooserButton.text")); // NOI18N
        fileChooserButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                fileChooserButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(25, 25, 25)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(karafPathLabel, javax.swing.GroupLayout.DEFAULT_SIZE, 140, Short.MAX_VALUE)
                            .addComponent(karafNameLabel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                        .addGap(26, 26, 26)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(karafPathTextField, javax.swing.GroupLayout.DEFAULT_SIZE, 458, Short.MAX_VALUE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(fileChooserButton))
                            .addComponent(karafNameTextField, javax.swing.GroupLayout.DEFAULT_SIZE, 547, Short.MAX_VALUE))
                        .addContainerGap())
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(cleanLabel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jLabel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(debugPortLabel, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 140, Short.MAX_VALUE))
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(layout.createSequentialGroup()
                                .addGap(26, 26, 26)
                                .addComponent(karafServerInfoLabel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                            .addGroup(layout.createSequentialGroup()
                                .addGap(27, 27, 27)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(cleanCheckbox)
                                    .addComponent(debugPortTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 61, javax.swing.GroupLayout.PREFERRED_SIZE))
                                .addGap(0, 0, Short.MAX_VALUE))))))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(12, 12, 12)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(karafNameLabel)
                    .addComponent(karafNameTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(karafPathLabel)
                    .addComponent(karafPathTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(fileChooserButton))
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(karafServerInfoLabel)
                    .addComponent(jLabel1))
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(cleanCheckbox, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(cleanLabel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(debugPortLabel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(0, 0, Short.MAX_VALUE)
                        .addComponent(debugPortTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addGap(125, 125, 125))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void cleanCheckboxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cleanCheckboxActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_cleanCheckboxActionPerformed

    private void debugPortTextFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_debugPortTextFieldActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_debugPortTextFieldActionPerformed

    private void fileChooserButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_fileChooserButtonActionPerformed
        JFileChooser fileChooser = new JFileChooser();
        fileChooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
        fileChooser.setAcceptAllFileFilterUsed(false);
        if (fileChooser.showOpenDialog(this) == JFileChooser.APPROVE_OPTION) {
            karafPathTextField.setText(fileChooser.getSelectedFile().getAbsolutePath());
        }
    }//GEN-LAST:event_fileChooserButtonActionPerformed


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JCheckBox cleanCheckbox;
    private javax.swing.JLabel cleanLabel;
    private javax.swing.JLabel debugPortLabel;
    private javax.swing.JTextField debugPortTextField;
    private javax.swing.JButton fileChooserButton;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel karafNameLabel;
    private javax.swing.JTextField karafNameTextField;
    private javax.swing.JLabel karafPathLabel;
    private javax.swing.JTextField karafPathTextField;
    private javax.swing.JLabel karafServerInfoLabel;
    // End of variables declaration//GEN-END:variables

    @Override
    public void insertUpdate(DocumentEvent e) {
        updateInfoAndValidate();
    }

    @Override
    public void removeUpdate(DocumentEvent e) {
        updateInfoAndValidate();
    }

    @Override
    public void changedUpdate(DocumentEvent e) {
        updateInfoAndValidate();
    }

    private void updateInfoAndValidate() {
        updateKarafInfo();
    }

    private void updateKarafInfo() {
        String serverInfo = KarafServerInfoHelper.getServerInfoFromPath(karafPathTextField.getText());
        karafServerInfoLabel.setText(serverInfo);
    }

    public String getFormError() {
        if (karafNameTextField.getText().isEmpty()) {
            return "Name is mandatory";
        } else if (karafServerInfoLabel.getText().isEmpty()) {
            return "Specified path is not a valid Karaf Server path";
        } else {
            return "";
        }
    }

    public String getInstanceName() {
        return karafNameTextField.getText();
    }

    public String getInstancePath() {
        return karafPathTextField.getText();
    }

    @Override
    public String getName() {
        return "Instance Properties";
    }

    public boolean isCleanOnStart() {
        return cleanCheckbox.isSelected();
    }

    public Integer getDebuggerPort() {
        String debugPort = debugPortTextField.getText();
        if (debugPort == null || debugPort.isEmpty()) {
            return 0;
        } else {
            return new Integer(debugPortTextField.getText());
        }
    }
}
